> For the complete documentation index, see [llms.txt](https://docs.redivis.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.redivis.com/api/client-libraries/redivis-r/reference/directory/directoryusdlist.md).

# Directory$list

### Directory$<mark style="color:purple;">list</mark>(*max\_results,* *mode, recursive*) → list([File](/api/client-libraries/redivis-r/reference/file.md) | [Directory](/api/client-libraries/redivis-r/reference/directory.md))

List the contents of a given directory.

### **Parameters:**

**`max_results` :&#x20;*****int, default NULL***\
If specified, will only list up to the specified number of files and/or directories

**`mode` :&#x20;*****"all" | "files" | "directories", default "all"***\
By default, this method will return a list of files *and* directories within the current directory. Specify an alternative mode to only list a given entity type.

**`recursive` :** ***bool, default FALSE***\
Whether to recursively crawl the directory tree and return all files and/or directories. If `FALSE` (the default), only entities directly in this directory will be returned.

### **Returns:**&#x20;

**list(** [**File**](/api/client-libraries/redivis-r/reference/file.md) **|** [**Directory**](/api/client-libraries/redivis-r/reference/directory.md) **)**

### Examples:

```r
dir <- redivis$table("table_ref")$to_directory()
print(dir$list()) # list files + directories within this directory

all_files <- dir$list(mode="files", recursive=TRUE)
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.redivis.com/api/client-libraries/redivis-r/reference/directory/directoryusdlist.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
